<template lang="pug">
.row.x-materialinfo
  .col-12.py-3.justify-content-center.d-flex(v-if='!loading && $butils.isNil(material)' key='noSuch')
    span.alert.alert-secondary Unknown Material
  .col-12(v-if='material' key='material')
    BaseCard
      template(v-slot:header='')
        BaseAnimationBlock
          .justify-content-center.d-flex(v-if='loading' key='loading')
            h1 #[i.align-bottom.fa.fa-spinner.fa-pulse]
          .d-flex.justify-content-between.align-items-center(v-else key='title')
            h5 {{ material.type | startCase }} #[span.text-muted {{ "#" + material.id }}]
            router-link.text-dark.text-muted.clickable.ml-1(:to='getRoute("/materials?type=" + material.type)')
              .fa.fa-caret-up
            .ml-auto.clickable(@click='setEdit(true)' v-if='canEdit && !inEdit')
              kbd.keyHint.mr-2(v-if="showKeyHints") E
              i.fa.fa-cog
            .ml-auto.clickable(@click='setEdit(false)' v-if='canEdit && inEdit')
              kbd.keyHint.mr-2(v-if="showKeyHints") Esc
              i.fa.fa-times
      li(v-if='!materialLoading && !inEdit' key='info')
        mixin info(name)
          .row&attributes(attributes)
            .col-12.text-left.col-sm-3.col-lg-2
              strong= name
            .col-12.text-right.col-sm-9.col-lg-10.text-sm-left
              block
        +info('Id') {{ material.id }}
        +info('Title') {{ material.title }}
        +info('Status')
          .fa.fa-check(v-if='material.status')
          .fa.fa-times(v-else)
        +info('Compound')
          sup(v-if='material.massNumber > 0') {{ material.massNumber }}
          sub(v-if='material.atomicNumber > 0') {{ material.atomicNumber }}
          | {{ material.compound }}
        +info('Mass')(:title='material.mass') {{ material.mass | b-bigNumber(' mg') }}
        +info('Thickness')(:title='material.thickness') {{ material.thickness | b-bigNumber(' \u00B5m') }}
        +info('Diameter')(:title='material.diameter') {{ material.diameter | b-bigNumber(' mm')}}
        +info('Area Density')(:title='material.areaDensity') {{ material.areaDensity | b-bigNumber(' \u00B5g/cm\u00B2')}}
      li(v-if='!materialLoading && inEdit' key='edit')
        .row.b-param-container
          BaseParamInput.col-12.col-sm-9(ref='title' title='Title' :inEdit='true' :value='material.title')
          BaseParamToggle.col-12.col-sm-3(ref='status' title='Status' :inEdit='true' :value='!!material.status')
          BaseParamInput.col-12.col-lg-4(ref='compound' title='Element / Compound' :inEdit='true' :value='material.compound')
          BaseParamInput.col-12.col-sm-6.col-lg-4(ref='massNumber' type='number' step='1'
            title='Mass Number' :inEdit='true' :value='material.massNumber')
          BaseParamInput.col-12.col-sm-6.col-lg-4(ref='atomicNumber' type='number' step='1'
            title='Atomic Number' :inEdit='true' :value='material.atomicNumber')
          BaseParamInput.col-12.col-sm-6.col-md-3(ref='mass' type='number' step='any'
            title='Mass [mg]' :inEdit='true' :value='material.mass')
          BaseParamInput.col-12.col-sm-6.col-md-3(ref='thickness' type='number' step='any'
            title='Thickness [\u00B5m]' :inEdit='true' :value='material.thickness')
          BaseParamInput.col-12.col-sm-6.col-md-3(ref='diameter' type='number' step='any'
            title='Diameter [mm]' :inEdit='true' :value='material.diameter')
          BaseParamInput.col-12.col-sm-6.col-md-3(ref='areaDensity' type='number' step='any'
            title='Area Density [\u00B5g/cm\u00B2]' :inEdit='true' :value='material.areaDensity')
      li.px-0.pt-0.x-desc(v-if='!materialLoading' key='desc')
        BaseMarkdownWidget(ref='description' :inEdit='inEdit' :value='material.description')
      li.x-docs(key='docs')
        DocumentsList(:inEdit='inEdit' parentType='materials' :parentItem='material')
      li.x-setups(v-if='!setupsLoading' key='setups')
        DBCollapsible(title='Material Setups' source='materialsSetups'
                      parentType='materials' :parentItem='material' :query='{ sort: "id:desc" }')
          template(v-slot:row='row')
            router-link.text-primary.text-truncate(:key='row.id' :to='getRoute(`/materials/setups/${row.id}`)') {{ row.name }}
      li(v-if='!loading && inEdit' key='submit')
        .d-flex.justify-content-end
          button.btn.btn-danger.mx-1.x-delete(v-if='isAdmin' @click="doDelete()" title='Delete Material')
            i.fa.fa-trash
          router-link.btn.btn-outline-danger.ml-1.x-admin(v-if='!isAdmin && $store.getters.canAdmin' :to='"/admin" + $route.fullPath' title='admin')
            i.fa.fa-key
          button.btn.btn-primary.mx-1.x-submit(@click="doSubmit()")
            kbd.keyHint.mr-2(v-if="showKeyHints") Ctrl+S
            i.fa.fa-upload.mr-1(v-else)
            | Submit
        BaseDialog(v-if='isAdmin' ref='deleteDialog' title='Delete Material')
          template(v-if='!$butils.isEmpty(setups)')
            p This material is used in some setups.
            p.mb-0 It must be removed from all setups.
          template(v-else-if='!$butils.isEmpty(docs)')
            p This material has attached documents.
            p.mb-0 All documents must be deleted.
          template(v-else)
            p This will permanently delete the material.
            p.mb-0 do you confirm this action ?
          template(v-slot:footer='d')
            button.btn.btn-primary(v-if='!$butils.isEmpty(setups) || !$butils.isEmpty(docs)'
              @click='d.resolve(false)') Cancel
            template(v-else)
              button.mr-1.btn.btn-secondary(@click='d.resolve(false)') Cancel
              button.btn.btn-danger(@click='d.resolve(true)') Ok
</template>
<script>
export { default } from './MaterialInfo.vue.js';
</script>
<style lang='scss'>
.x-materialinfo {
  .b-markdown-preview {
    padding-top: .75rem;
    padding-left: 15px;
    padding-right: 15px;
  }
  .x-desc {
    // preview ribbon must be over other elts
    z-index: 1;
  }
}
</style>
